package com.edu.base;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;

/**
 * Created by KangJellen on 2017/4/25.
 */
@ApiModel(description = "通用返回对象")
public class ResponseEntity<T> implements Serializable {

    @ApiModelProperty("返回码")
    private String code = "000000";

    @ApiModelProperty("返回信息")
    private String msg;

    @ApiModelProperty("返回实体对象信息")
    private T data;

    @ApiModelProperty("总条数")
    private long count;

    public ResponseEntity() {
    }

    public ResponseEntity(T data) {
        this.data = data;
    }

    public ResponseEntity(T data, long count) {
        this.data = data;
        this.count = count;
    }

    public ResponseEntity(String code, String msg) {
        this.code = code;
        this.msg = msg;
    }

    public String getMsg() {
        return this.msg;
    }

    public ResponseEntity<T> setMsg(String msg) {
        this.msg = msg;
        return this;
    }

    public T getData() {
        return this.data;
    }

    public ResponseEntity<T> setData(T data) {
        this.data = data;
        return this;
    }

    public long getCount() {
        return this.count;
    }

    public void setCount(long count) {
        this.count = count;
    }

    public String getCode() {
        return this.code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String toString() {
        return "ResponseEntity(super=" + super.toString() + ", msg=" + getMsg() + ", data=" + getData() + ", count=" + getCount() + ", code=" + getCode() + ")";
    }
}